# coding: utf-8

"""
    CNB OPENAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Contact: cnb@tencent.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cnb_api.models.v1_descriptor import V1Descriptor
from typing import Optional, Set
from typing_extensions import Self

class DtoManifestMetadata(BaseModel):
    """
    DtoManifestMetadata
    """ # noqa: E501
    annotations: Optional[Dict[str, StrictStr]] = Field(default=None, description="Annotations contains arbitrary metadata for the image manifest.")
    artifact_type: Optional[StrictStr] = Field(default=None, description="ArtifactType specifies the IANA media type of artifact when the manifest is used for an artifact.", alias="artifactType")
    config: Optional[V1Descriptor] = Field(default=None, description="Config references a configuration object for a container, by digest. The referenced configuration object is a JSON blob that the runtime uses to set up the container.")
    layers: Optional[List[V1Descriptor]] = Field(default=None, description="Layers is an indexed list of layers referenced by the manifest.")
    manifests: Optional[List[V1Descriptor]] = Field(default=None, description="Manifests references platform specific manifests.")
    media_type: Optional[StrictStr] = Field(default=None, description="MediaType specifies the type of this document data structure e.g. `application/vnd.oci.image.manifest.v1+json`", alias="mediaType")
    schema_version: Optional[StrictInt] = Field(default=None, description="SchemaVersion is the image manifest schema that this image follows", alias="schemaVersion")
    subject: Optional[V1Descriptor] = Field(default=None, description="Subject is an optional link from the image manifest to another manifest forming an association between the image manifest and the other manifest.")
    __properties: ClassVar[List[str]] = ["annotations", "artifactType", "config", "layers", "manifests", "mediaType", "schemaVersion", "subject"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DtoManifestMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of config
        if self.config:
            _dict['config'] = self.config.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in layers (list)
        _items = []
        if self.layers:
            for _item_layers in self.layers:
                if _item_layers:
                    _items.append(_item_layers.to_dict())
            _dict['layers'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in manifests (list)
        _items = []
        if self.manifests:
            for _item_manifests in self.manifests:
                if _item_manifests:
                    _items.append(_item_manifests.to_dict())
            _dict['manifests'] = _items
        # override the default output from pydantic by calling `to_dict()` of subject
        if self.subject:
            _dict['subject'] = self.subject.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DtoManifestMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "annotations": obj.get("annotations"),
            "artifactType": obj.get("artifactType"),
            "config": V1Descriptor.from_dict(obj["config"]) if obj.get("config") is not None else None,
            "layers": [V1Descriptor.from_dict(_item) for _item in obj["layers"]] if obj.get("layers") is not None else None,
            "manifests": [V1Descriptor.from_dict(_item) for _item in obj["manifests"]] if obj.get("manifests") is not None else None,
            "mediaType": obj.get("mediaType"),
            "schemaVersion": obj.get("schemaVersion"),
            "subject": V1Descriptor.from_dict(obj["subject"]) if obj.get("subject") is not None else None
        })
        return _obj


