# coding: utf-8

"""
    CNB OPENAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Contact: cnb@tencent.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cnb_api.models.constant_repo_display_module import ConstantRepoDisplayModule
from cnb_api.models.constant_repo_status import ConstantRepoStatus
from cnb_api.models.constant_visibility import ConstantVisibility
from cnb_api.models.convert_null_time import ConvertNullTime
from cnb_api.models.dto_rank_detail_tags_inner import DtoRankDetailTagsInner
from cnb_api.models.dto_repo_language import DtoRepoLanguage
from cnb_api.models.dto_slugs import DtoSlugs
from typing import Optional, Set
from typing_extensions import Self

class DtoRankDetail(BaseModel):
    """
    DtoRankDetail
    """ # noqa: E501
    created_at: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    display_module: Optional[ConstantRepoDisplayModule] = None
    fork_count: Optional[StrictInt] = None
    forked_from_repo: Optional[DtoSlugs] = Field(default=None, description="预留")
    freeze: Optional[StrictBool] = None
    id: Optional[StrictInt] = None
    language: Optional[StrictStr] = Field(default=None, description="仓库程序语言，预留")
    languages: Optional[DtoRepoLanguage] = Field(default=None, description="仓库语言")
    last_update_nickname: Optional[StrictStr] = Field(default=None, description="最新代码更新人姓名")
    last_update_username: Optional[StrictStr] = Field(default=None, description="最新代码更新人账户名")
    last_updated_at: Optional[ConvertNullTime] = Field(default=None, description="最新代码更新时间")
    license: Optional[StrictStr] = None
    mark_count: Optional[StrictInt] = None
    name: Optional[StrictStr] = None
    open_issue_count: Optional[StrictInt] = Field(default=None, description="开启的issue数")
    open_pull_request_count: Optional[StrictInt] = Field(default=None, description="开启的pull request数")
    path: Optional[StrictStr] = Field(default=None, description="完整仓库路径")
    rank_value: Optional[StrictInt] = None
    site: Optional[StrictStr] = None
    star_count: Optional[StrictInt] = None
    status: Optional[ConstantRepoStatus] = None
    tags: Optional[List[DtoRankDetailTagsInner]] = None
    topics: Optional[StrictStr] = None
    updated_at: Optional[StrictStr] = None
    visibility_level: Optional[ConstantVisibility] = None
    web_url: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["created_at", "description", "display_module", "fork_count", "forked_from_repo", "freeze", "id", "language", "languages", "last_update_nickname", "last_update_username", "last_updated_at", "license", "mark_count", "name", "open_issue_count", "open_pull_request_count", "path", "rank_value", "site", "star_count", "status", "tags", "topics", "updated_at", "visibility_level", "web_url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DtoRankDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "freeze",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of forked_from_repo
        if self.forked_from_repo:
            _dict['forked_from_repo'] = self.forked_from_repo.to_dict()
        # override the default output from pydantic by calling `to_dict()` of languages
        if self.languages:
            _dict['languages'] = self.languages.to_dict()
        # override the default output from pydantic by calling `to_dict()` of last_updated_at
        if self.last_updated_at:
            _dict['last_updated_at'] = self.last_updated_at.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in tags (list)
        _items = []
        if self.tags:
            for _item_tags in self.tags:
                if _item_tags:
                    _items.append(_item_tags.to_dict())
            _dict['tags'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DtoRankDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "description": obj.get("description"),
            "display_module": obj.get("display_module"),
            "fork_count": obj.get("fork_count"),
            "forked_from_repo": DtoSlugs.from_dict(obj["forked_from_repo"]) if obj.get("forked_from_repo") is not None else None,
            "freeze": obj.get("freeze"),
            "id": obj.get("id"),
            "language": obj.get("language"),
            "languages": DtoRepoLanguage.from_dict(obj["languages"]) if obj.get("languages") is not None else None,
            "last_update_nickname": obj.get("last_update_nickname"),
            "last_update_username": obj.get("last_update_username"),
            "last_updated_at": ConvertNullTime.from_dict(obj["last_updated_at"]) if obj.get("last_updated_at") is not None else None,
            "license": obj.get("license"),
            "mark_count": obj.get("mark_count"),
            "name": obj.get("name"),
            "open_issue_count": obj.get("open_issue_count"),
            "open_pull_request_count": obj.get("open_pull_request_count"),
            "path": obj.get("path"),
            "rank_value": obj.get("rank_value"),
            "site": obj.get("site"),
            "star_count": obj.get("star_count"),
            "status": obj.get("status"),
            "tags": [DtoRankDetailTagsInner.from_dict(_item) for _item in obj["tags"]] if obj.get("tags") is not None else None,
            "topics": obj.get("topics"),
            "updated_at": obj.get("updated_at"),
            "visibility_level": obj.get("visibility_level"),
            "web_url": obj.get("web_url")
        })
        return _obj


