# coding: utf-8

"""
    CNB OPENAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Contact: cnb@tencent.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cnb_api.models.git_woa_com_cnb_monorepo_git_internal_dto_web_user_info import GitWoaComCnbMonorepoGitInternalDtoWebUserInfo
from cnb_api.models.web_cs_detail import WebCSDetail
from cnb_api.models.web_issue_type import WebIssueType
from cnb_api.models.web_raw_author import WebRawAuthor
from typing import Optional, Set
from typing_extensions import Self

class WebCodeSensitiveDetail(BaseModel):
    """
    WebCodeSensitiveDetail
    """ # noqa: E501
    created_at: Optional[StrictStr] = Field(default=None, description="问题创建时间")
    cs_sub_type: Optional[WebIssueType] = Field(default=None, description="问题子类型")
    cs_type: Optional[WebIssueType] = Field(default=None, description="问题类型")
    file_name: Optional[StrictStr] = Field(default=None, description="包含问题的文件名")
    file_path: Optional[StrictStr] = Field(default=None, description="包含问题的文件路径")
    handler: Optional[GitWoaComCnbMonorepoGitInternalDtoWebUserInfo] = Field(default=None, description="忽略人(平台信息)")
    id: Optional[StrictStr] = Field(default=None, description="问题id")
    ignore_reason: Optional[StrictStr] = Field(default=None, description="忽略原因")
    ignored_at: Optional[StrictStr] = Field(default=None, description="忽略时间")
    issue_detail: Optional[List[WebCSDetail]] = Field(default=None, description="问题详情")
    line_no: Optional[List[StrictInt]] = Field(default=None, description="问题行号")
    occur_version: Optional[StrictStr] = Field(default=None, description="问题发生版本")
    owner: Optional[GitWoaComCnbMonorepoGitInternalDtoWebUserInfo] = Field(default=None, description="问题责任人(平台信息)")
    raw_author: Optional[WebRawAuthor] = Field(default=None, description="问题责任人原生git信息")
    reopen_at: Optional[StrictStr] = Field(default=None, description="重新开启时间")
    reopen_handler: Optional[GitWoaComCnbMonorepoGitInternalDtoWebUserInfo] = Field(default=None, description="重新开启人")
    revision: Optional[StrictStr] = Field(default=None, description="问题所在版本")
    risk_level: Optional[StrictStr] = Field(default=None, description="问题等级")
    state: Optional[StrictStr] = Field(default=None, description="问题状态 开启/忽略")
    tool: Optional[StrictStr] = Field(default=None, description="扫描工具")
    __properties: ClassVar[List[str]] = ["created_at", "cs_sub_type", "cs_type", "file_name", "file_path", "handler", "id", "ignore_reason", "ignored_at", "issue_detail", "line_no", "occur_version", "owner", "raw_author", "reopen_at", "reopen_handler", "revision", "risk_level", "state", "tool"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebCodeSensitiveDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cs_sub_type
        if self.cs_sub_type:
            _dict['cs_sub_type'] = self.cs_sub_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cs_type
        if self.cs_type:
            _dict['cs_type'] = self.cs_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of handler
        if self.handler:
            _dict['handler'] = self.handler.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in issue_detail (list)
        _items = []
        if self.issue_detail:
            for _item_issue_detail in self.issue_detail:
                if _item_issue_detail:
                    _items.append(_item_issue_detail.to_dict())
            _dict['issue_detail'] = _items
        # override the default output from pydantic by calling `to_dict()` of owner
        if self.owner:
            _dict['owner'] = self.owner.to_dict()
        # override the default output from pydantic by calling `to_dict()` of raw_author
        if self.raw_author:
            _dict['raw_author'] = self.raw_author.to_dict()
        # override the default output from pydantic by calling `to_dict()` of reopen_handler
        if self.reopen_handler:
            _dict['reopen_handler'] = self.reopen_handler.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebCodeSensitiveDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created_at": obj.get("created_at"),
            "cs_sub_type": WebIssueType.from_dict(obj["cs_sub_type"]) if obj.get("cs_sub_type") is not None else None,
            "cs_type": WebIssueType.from_dict(obj["cs_type"]) if obj.get("cs_type") is not None else None,
            "file_name": obj.get("file_name"),
            "file_path": obj.get("file_path"),
            "handler": GitWoaComCnbMonorepoGitInternalDtoWebUserInfo.from_dict(obj["handler"]) if obj.get("handler") is not None else None,
            "id": obj.get("id"),
            "ignore_reason": obj.get("ignore_reason"),
            "ignored_at": obj.get("ignored_at"),
            "issue_detail": [WebCSDetail.from_dict(_item) for _item in obj["issue_detail"]] if obj.get("issue_detail") is not None else None,
            "line_no": obj.get("line_no"),
            "occur_version": obj.get("occur_version"),
            "owner": GitWoaComCnbMonorepoGitInternalDtoWebUserInfo.from_dict(obj["owner"]) if obj.get("owner") is not None else None,
            "raw_author": WebRawAuthor.from_dict(obj["raw_author"]) if obj.get("raw_author") is not None else None,
            "reopen_at": obj.get("reopen_at"),
            "reopen_handler": GitWoaComCnbMonorepoGitInternalDtoWebUserInfo.from_dict(obj["reopen_handler"]) if obj.get("reopen_handler") is not None else None,
            "revision": obj.get("revision"),
            "risk_level": obj.get("risk_level"),
            "state": obj.get("state"),
            "tool": obj.get("tool")
        })
        return _obj


