# coding: utf-8

"""
    CNB OPENAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Contact: cnb@tencent.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cnb_api.models.web_commit import WebCommit
from cnb_api.models.web_file_stat import WebFileStat
from cnb_api.models.web_preload_file import WebPreloadFile
from cnb_api.models.web_repository import WebRepository
from typing import Optional, Set
from typing_extensions import Self

class WebFileContent(BaseModel):
    """
    WebFileContent
    """ # noqa: E501
    branch_count: Optional[StrictInt] = None
    cnb_settings: Optional[WebPreloadFile] = None
    commit_count: Optional[StrictInt] = None
    commit_count_exceeded: Optional[StrictBool] = None
    content: Optional[StrictStr] = None
    encoding: Optional[StrictStr] = None
    file_size_exceeded: Optional[StrictBool] = None
    file_size_limit: Optional[StrictInt] = None
    file_stat: Optional[WebFileStat] = None
    initialized: Optional[StrictBool] = None
    is_lfs: Optional[StrictBool] = None
    is_protected: Optional[StrictBool] = Field(default=None, description="如果当前访问的是分支，那么表示是否是保护分支")
    last_commit: Optional[WebCommit] = None
    lfs_hash_algorithm: Optional[StrictStr] = None
    lfs_oid: Optional[StrictStr] = None
    lfs_size_in_byte: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    path: Optional[StrictStr] = None
    repository: Optional[WebRepository] = None
    size: Optional[StrictInt] = None
    tag_count: Optional[StrictInt] = None
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["branch_count", "cnb_settings", "commit_count", "commit_count_exceeded", "content", "encoding", "file_size_exceeded", "file_size_limit", "file_stat", "initialized", "is_lfs", "is_protected", "last_commit", "lfs_hash_algorithm", "lfs_oid", "lfs_size_in_byte", "name", "path", "repository", "size", "tag_count", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WebFileContent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cnb_settings
        if self.cnb_settings:
            _dict['cnb_settings'] = self.cnb_settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of file_stat
        if self.file_stat:
            _dict['file_stat'] = self.file_stat.to_dict()
        # override the default output from pydantic by calling `to_dict()` of last_commit
        if self.last_commit:
            _dict['last_commit'] = self.last_commit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of repository
        if self.repository:
            _dict['repository'] = self.repository.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WebFileContent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "branch_count": obj.get("branch_count"),
            "cnb_settings": WebPreloadFile.from_dict(obj["cnb_settings"]) if obj.get("cnb_settings") is not None else None,
            "commit_count": obj.get("commit_count"),
            "commit_count_exceeded": obj.get("commit_count_exceeded"),
            "content": obj.get("content"),
            "encoding": obj.get("encoding"),
            "file_size_exceeded": obj.get("file_size_exceeded"),
            "file_size_limit": obj.get("file_size_limit"),
            "file_stat": WebFileStat.from_dict(obj["file_stat"]) if obj.get("file_stat") is not None else None,
            "initialized": obj.get("initialized"),
            "is_lfs": obj.get("is_lfs"),
            "is_protected": obj.get("is_protected"),
            "last_commit": WebCommit.from_dict(obj["last_commit"]) if obj.get("last_commit") is not None else None,
            "lfs_hash_algorithm": obj.get("lfs_hash_algorithm"),
            "lfs_oid": obj.get("lfs_oid"),
            "lfs_size_in_byte": obj.get("lfs_size_in_byte"),
            "name": obj.get("name"),
            "path": obj.get("path"),
            "repository": WebRepository.from_dict(obj["repository"]) if obj.get("repository") is not None else None,
            "size": obj.get("size"),
            "tag_count": obj.get("tag_count"),
            "type": obj.get("type")
        })
        return _obj


